// JavaScript Document
function CUI(game){
	this.status=0;
	this.mainDiv=false;
	this.scaleVal=1.0;
	this.lastTime=0;
	this.Zindex=0;
	this.Images=new Array();
	this.Load=Load;function Load(){
		var a=0;
		var ImageFolder=game.homeURL+'assets/images/ui/';
		preloadImage(this.Images,a,ImageFolder+'blueBG.png');a++;//0:blue background
		preloadImage(this.Images,a,ImageFolder+'cloud.png');a++;//1:menu cloud
		preloadImage(this.Images,a,ImageFolder+'Small tilted box.png');a++;//2:menu top box
		preloadImage(this.Images,a,ImageFolder+'groupBox.png');a++;//3:box
		
		if(game.gameDiv)game.gameDiv.innerHTML+='<div id="UIContainer" style="background-image:url('+this.Images[0].src+');" onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;"></div>';
		this.mainDiv=document.getElementById('UIContainer');
		_boundingBox=this.mainDiv;
	}
	this.LoadOk=LoadOk;function LoadOk(){
		if(!this.mainDiv)return(false);
		if(!imagesLoaded(this.Images))return(false);
		return(true);
	}
	this.Run=Run;function Run(mode){
		switch(mode){
			case('main menu'):this.mainMenu();break;
			case('starting game'):this.startingGame();break;
			case('playing'):this.playing();break;
			case('game over'):this.gameOver();break;
			default:this.LoadingScreen();break;
		}
	}
	
	this.LoadingScreen=LoadingScreen;function LoadingScreen(){
		var html;
		if(this.status=='Loading'){
			if(this.lastTime+300<game.time){
				this.dotCount+=1;
				if(this.dotCount>3)this.dotCount=0;
				this.lastTime=game.time;
			}
			var obj=document.getElementById('LoadingDiv');
			if(obj){
				html='Loading';
				for(var i=0;i<this.dotCount;i++)html+='.';
				obj.innerHTML=html;
			}
		}else{
			this.status='Loading';
			obj=document.getElementById('UIContainer');if(obj)obj.style.backgroundPosition='top';
			this.lastTime=game.time;
			html='<div id="mainMenu_top" style="height:'+(400*this.scaleVal)+'px;background:none;"><div align="left" id="LoadingDiv" style="margin-left:45%;font-size:'+(20*this.scaleVal)+'px;color:#fcf9f7;">';
			if(!this.dotCount)this.dotCount=0;
			html+='</div></div>';
			this.mainDiv.innerHTML=html;
		}
	}
	
	this.mainMenu=mainMenu;function mainMenu(){
//		console.log(game.config);
		var html;
		if(this.status=='main menu'){
		}else{
			this.status='main menu';
			var i;
			obj=document.getElementById('UIContainer');if(obj)obj.style.backgroundPosition='top';
			html='<div id="mainMenu_top" style="height:'+(69*this.scaleVal)+'px;font-size:'+(22*this.scaleVal)+'px;"><div align="center">';
				html+='<img class="flippedImg" src="'+this.Images[2].src+'" width="'+(50*this.scaleVal)+'" height="'+(39*this.scaleVal)+'" />';
				html+=game.config.menuTexts.MenuScreenTitle;
				html+='<img src="'+this.Images[2].src+'" width="'+(50*this.scaleVal)+'" height="'+(39*this.scaleVal)+'" />';
			html+='</div></div>';
			html+='<div id="mainMenu_cloud" style="background-image:url('+this.Images[1].src+');width:'+(229*this.scaleVal)+'px;font-size:'+(20*this.scaleVal)+'px;">';
				html+='<div style="margin-left:-8%;margin-top:2%;height:'+(32*this.scaleVal)+'px;">'+game.config.menuTexts.Menu+'</div>';
				html+='<div id="mainMenu_box" style="width:'+(210*this.scaleVal)+'px;font-size:'+(10*this.scaleVal)+'px;">';
					html+='<div></div><div>'+game.config.menuTexts.WouldYou+'</div>';
					html+='<div></div><div onclick="game.newGame(-1);" class="menuButton yellow" style="background-position:center bottom;width:'+(150*this.scaleVal)+'px;height:'+(27*this.scaleVal)+'px;"><div>'+game.config.menuTexts.RandomModeButton+'</div></div>';
					html+='<div>'+game.config.menuTexts.ChoosingTopic+'</div>';
					for(i=0;i<game.config.categories.length;i++){
						html+='<div onclick="game.newGame('+i+');" class="menuButton" style="width:'+(150*this.scaleVal)+'px;height:'+(27*this.scaleVal)+'px;"><div>'+game.config.categories[i].text+'</div></div>';
					}
				html+='</div>';
			html+='</div>';
			this.mainDiv.innerHTML=html;
		}
	}
	
	this.startingGame=startingGame;function startingGame(){
		var html,obj,i,w,h,a,b,done,ok,x;
		if(this.status=='starting game'){
			//background and boxes
			startingGame.backgroundSlide+=5;
			if(startingGame.backgroundSlide>100)startingGame.backgroundSlide=100;
			obj=document.getElementById('UIContainer');
			if(obj)obj.style.backgroundPosition='0px -'+(startingGame.backgroundSlide*this.scaleVal)+'px';
			obj=document.getElementById('boxesContainer');
			if(obj)obj.style.marginTop=((500-startingGame.backgroundSlide*1.45)*this.scaleVal)+'px';
			//cards
			ok=true;
			if(startingGame.time+10<game.time){
				startingGame.currentCard++;
				if(startingGame.currentCard>game.categ.Elements.length)startingGame.currentCard=game.categ.Elements.length;
				startingGame.time=game.time;
			}
			if(startingGame.currentCard<game.categ.Elements.length)ok=false;
			//game.categ.Elements
			for(i=0;i<startingGame.currentCard;i++){
				done=false;
				if(game.categ.Elements[i].x<game.categ.Elements[i].Dx && game.categ.Elements[i].dx<0)done=true;
				else if(game.categ.Elements[i].x>game.categ.Elements[i].Dx && game.categ.Elements[i].dx>0)done=true;
				else if(game.categ.Elements[i].y>game.categ.Elements[i].Dy && game.categ.Elements[i].dy>0)done=true;
				else if(game.categ.Elements[i].y<game.categ.Elements[i].Dy && game.categ.Elements[i].dy<0)done=true;
				if(done)continue;
				ok=false;
				game.categ.Elements[i].x+=game.categ.Elements[i].dx;
				game.categ.Elements[i].y+=game.categ.Elements[i].dy;
				game.categ.Elements[i].rot+=game.categ.Elements[i].drot;
				obj=document.getElementById('card_'+i);
				if(obj){
					obj.style.left=game.categ.Elements[i].x+'px';
					obj.style.top=game.categ.Elements[i].y+'px';
					setAngle(obj,game.categ.Elements[i].rot);
					obj.style.zIndex=50+i;
				}
			}
			if(ok){
				game.status='playing';
			}
		}else{
			this.totalPlaced=0;
			obj=document.getElementById('UIContainer');if(obj)obj.style.backgroundPosition='top';
			startingGame.backgroundSlide=0.0;
			this.status='starting game';
			html='<div id="boxesContainer" style="margin-top:'+(500*this.scaleVal)+'px;">';
			for(i=0;i<game.categ.Sub_Category.length;i++){
				html+='<input type="hidden" id="subcategBox_'+i+'_val" value="'+i+'" />';
				switch(game.categ.Sub_Category.length){
					case(3):x=75+i*200;break;
					case(5):x=5+i*135;break;
					default:x=50+i*150;break;
				}
				html+='<div id="subcateg_'+i+'" class="boxSubcateg" style="z-index:9;top:0px;left:'+(x*this.scaleVal)+'px;background-image:url('+this.Images[3].src+');width:'+(130*this.scaleVal)+'px;height:'+(170*this.scaleVal)+'px;" align="left" onclick="game.UI.boxClicked('+i+');" onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;" >';
					w=game.categ.Sub_Category[i].Images[0].width;
					h=game.categ.Sub_Category[i].Images[0].height;
					if(w/h>7/5){
						h=h*70/w;
						w=70;
					}else{
						w=w*50/h;
						h=50;
					}
					html+='<div style="font-size:'+(9*this.scaleVal)+'px;" align="center">'+game.categ.Sub_Category[i].title+'</div>';
					html+='<img src="'+game.categ.Sub_Category[i].Images[0].src+'" width="'+(w*this.scaleVal)+'" height="'+(h*this.scaleVal)+'" style="margin-left:'+(((70-w)/2+14)*this.scaleVal)+'px" />';
				html+='</div>';
				html+='<div id="subcategBox_'+i+'" class="boxSubcateg" style="z-index:10000;top:0px;left:'+(x*this.scaleVal)+'px;width:'+(130*this.scaleVal)+'px;height:'+(170*this.scaleVal)+'px;" align="left" onclick="game.UI.boxClicked('+i+');" onmouseover="this.mouseOver=true;" onmouseout="this.mouseOver=false;"></div>';
			}
			html+='</div>';
			
			for(i=0;i<game.categ.Elements.length;i++){
				a=game.categ.Elements[i].categ;b=game.categ.Elements[i].id;
				w=game.categ.Sub_Category[a].Elements[b].Images[0].width;
				h=game.categ.Sub_Category[a].Elements[b].Images[0].height;
					if(w/h>1){
						h=h*90/w;
						w=90;
					}else{
						w=w*90/h;
						h=90;
					}
				html+='<div id="card_'+i+'" class="card dragContainer" style="padding:'+(7*this.scaleVal)+'px;box-shadow: '+(5*this.scaleVal)+'px '+(5*this.scaleVal)+'px '+(30*this.scaleVal)+'px '+(5*this.scaleVal)+'px rgba(0,0,0,0.5);" align="center" onmousedown="game.UI.clicked('+i+');">';
					html+='<img class="dragChild" id="dragImg_'+i+'" src="'+game.categ.Sub_Category[a].Elements[b].Images[0].src+'" width="'+(w*this.scaleVal)+'" height="'+(h*this.scaleVal)+'"  draggable="false" />';
					html+='<div class="dragChild" style="font-size:'+(9*this.scaleVal)+'px;padding-top:'+(2*this.scaleVal)+'px;">'+game.categ.Sub_Category[a].Elements[b].name+'</div>';
					html+='<input type="hidden" id="card_'+i+'_val" value="'+i+'" />';
				html+='</div>';
			}
			this.mainDiv.innerHTML=html;
			startingGame.currentCard=0;startingGame.time=game.time;
			_dropBoxes.length=0;
			for(i=0;i<game.categ.Sub_Category.length;i++){
				obj=document.getElementById('subcategBox_'+i);
				if(obj){
					_dropBoxes[_dropBoxes.length]=obj;
				}
			}
			for(i=0;i<game.categ.Elements.length;i++){
				obj=document.getElementById('card_'+i);
				if(obj){
					obj.style.left=game.categ.Elements[i].x+'px';
					obj.style.top=game.categ.Elements[i].y+'px';
					setAngle(obj,game.categ.Elements[i].rot);
					obj.style.zIndex=50+i;
				}
			}
		}
	}
	
	this.playing=playing;function playing(){
		var i,obj;
		if(this.status=='playing'){
			for(i=0;i<game.categ.Elements.length;i++)if(Math.round(game.categ.Elements[i].x-game.categ.Elements[i].Dx) || Math.round(game.categ.Elements[i].y-game.categ.Elements[i].Dy)){
				game.categ.Elements[i].x+=game.categ.Elements[i].dx;
				game.categ.Elements[i].y+=game.categ.Elements[i].dy;
				game.categ.Elements[i].rot+=game.categ.Elements[i].drot;
				obj=document.getElementById('card_'+i);
				if(obj){
					obj.style.left=game.categ.Elements[i].x+'px';
					obj.style.top=game.categ.Elements[i].y+'px';
					setAngle(obj,game.categ.Elements[i].rot);
				}
				if(!Math.round(game.categ.Elements[i].x-game.categ.Elements[i].Dx) && !Math.round(game.categ.Elements[i].y-game.categ.Elements[i].Dy)){//done
					game.categ.Elements[i].x=game.categ.Elements[i].Dx;
					game.categ.Elements[i].y=game.categ.Elements[i].Dy;
					game.categ.Elements[i].rot=game.categ.Elements[i].Drot;
					obj.style.display='none';
				}
			}
		}else{
			this.status='playing'
			for(i=0;i<game.categ.Elements.length;i++){
				game.categ.Elements[i].x=game.categ.Elements[i].Dx;
				game.categ.Elements[i].y=game.categ.Elements[i].Dy;
				game.categ.Elements[i].rot=game.categ.Elements[i].Drot;
			}
		}
	}
	
	this.clicked=clicked;function clicked(id){
		var obj=document.getElementById('card_'+id);
		if(obj)obj.style.zIndex=this.Zindex++;
		obj=game.categ.Sub_Category[game.categ.Elements[id].categ].Elements[game.categ.Elements[id].id];
		if(obj.sound)obj.sound.Play();
		
	}
	
	this.drop=drop;function drop(element,box){
		var data = parseInt(element.id.substr(5));
		var obj=document.getElementById(box.id+'_val');
		if(!obj)obj=document.getElementById(box.parentNode.id+'_val');
		if(obj){
			if(game.categ.Elements[data].categ==obj.value){//match
				element.style.display='none';
				if(game.correct)game.correct.Play();
				this.totalPlaced++;
				if(this.totalPlaced>=game.categ.Elements.length){
					game.status='game over';
				}
				return(true);
			}else{//wrong box
				if(game.fail)game.fail.Play();
				return(false);
			}
		}

	}
	
	this.cardsUp=cardsUp;function cardsUp(){
		var i,j;
		var steps=10;
		var count=[],indx=[],sz=[];
		for(i=0;i<game.categ.Sub_Category.length;i++){
			for(j=0;j<game.categ.Elements.length;j++)if(game.categ.Elements[j].categ==i){
				if(!count[i])count[i]=1;else count[i]++;
			}
			indx[i]=0;
			sz[i]=Math.sqrt(count[i]);
		}
		for(i=0;i<game.categ.Elements.length;i++){
			game.categ.Elements[i].x=90*this.scaleVal;
			game.categ.Elements[i].y=50*this.scaleVal;
			j=game.categ.Elements[i].categ;
			game.categ.Elements[i].Dx=250+Math.floor(indx[j]%sz[j])*350/sz[j]+Math.random()*50;
			game.categ.Elements[i].Dy=50+Math.floor(indx[j]/sz[j])*200/sz[j]+Math.random()*50;
			indx[j]++;
			game.categ.Elements[i].Dx*=this.scaleVal;
			game.categ.Elements[i].Dy*=this.scaleVal;
			game.categ.Elements[i].rot=120.0;
			game.categ.Elements[i].Drot=45-Math.random()*90;
			game.categ.Elements[i].dx=(game.categ.Elements[i].Dx-game.categ.Elements[i].x)/steps;
			game.categ.Elements[i].dy=(game.categ.Elements[i].Dy-game.categ.Elements[i].y)/steps;
			game.categ.Elements[i].drot=(game.categ.Elements[i].Drot-game.categ.Elements[i].rot)/steps;
			obj=document.getElementById('card_'+i);
			if(obj){
				obj.style.left=game.categ.Elements[i].x+'px';
				obj.style.top=game.categ.Elements[i].y+'px';
				obj.style.display='none';
				obj.draggable=false;
			}
		}
	}
	
	this.boxClicked=boxClicked;function boxClicked(id){
//		var obj=document.getElementById('card_'+id);
//		if(obj)obj.style.zIndex=this.Zindex++;
		obj=game.categ.Sub_Category[id];
		if(obj.sound)obj.sound.Play();
		if(this.status=='game over' && this.clickedBox<0){
			this.clickedBox=id;
			this.cardsUp();
			this.clickedBoxStatus=0;
			obj=document.getElementById('subcateg_'+id);
			if(obj){
				this.boxX=this.boxDx=parseInt(obj.style.left);
				this.boxY=0;
				this.boxDy=200*this.scaleVal;
				this.boxdx=(this.boxDx-this.boxX)/10;
				this.boxdy=(this.boxDy-this.boxY)/10;
				this.boxStep=0;
			}
		}else if(this.status=='game over' && this.clickedBoxStatus==2){
			switch(game.categ.Sub_Category.length){
				case(3):this.boxDx=75+this.clickedBox*200;break;
				case(5):this.boxDx=5+this.clickedBox*135;break;
				default:this.boxDx=50+this.clickedBox*150;break;
			}
			this.boxDx*=this.scaleVal;
			this.boxDy=0;
			this.boxdx=(this.boxDx-this.boxX)/10;
			this.boxdy=(this.boxDy-this.boxY)/10;
			this.boxStep=0;
			this.clickedBoxStatus=3;
		}
	}
	
	this.gameOver=gameOver;function gameOver(){
		var i,obj,done;
		if(this.status=='game over'){
			FireworkSloop();
			if(this.clickedBox>=0 && this.clickedBoxStatus==0){//box slides down
				this.boxX+=this.boxdx;
				this.boxY+=this.boxdy;
				this.boxStep++;
				obj=document.getElementById('subcateg_'+this.clickedBox);
				if(obj){
					obj.style.left=this.boxX+'px';
					obj.style.top=this.boxY+'px';
				}
				if(this.boxStep>=10){
					this.clickedBoxStatus=1;
					this.boxX=-70*this.scaleVal;
					this.boxDx=-this.boxX;
					this.boxY=-390*this.scaleVal;
					this.boxDy=-320*this.scaleVal;
					this.boxdx=(this.boxDx-this.boxX)/5;
					this.boxdy=(this.boxDy-this.boxY)/5;
					this.boxStep=0;
				}
			}else if(this.clickedBox>=0 && this.clickedBoxStatus==1){//box moves to throw
				this.boxX+=this.boxdx;
				this.boxY+=this.boxdy;
				this.boxStep++;
				obj=document.getElementById('subcateg_'+this.clickedBox);
				if(obj){
					obj.style.left=this.boxX+'px';
					obj.style.top=this.boxY+'px';
					setAngle(obj,120);
				}
				if(this.boxStep>=5){
					this.clickedBoxStatus=2;
				}
			}else if(this.clickedBox>=0 && this.clickedBoxStatus==3){//box goes back down
				this.boxX+=this.boxdx;
				this.boxY+=this.boxdy;
				this.boxStep++;
				obj=document.getElementById('subcateg_'+this.clickedBox);
				if(obj){
					obj.style.left=this.boxX+'px';
					obj.style.top=this.boxY+'px';
					setAngle(obj,120-this.boxStep*12);
				}
				if(this.boxStep>=10){
					this.clickedBoxStatus=4;
					switch(game.categ.Sub_Category.length){
						case(3):this.boxDx=75+this.clickedBox*200;break;
						case(5):this.boxDx=5+this.clickedBox*135;break;
						default:this.boxDx=50+this.clickedBox*150;break;
					}
					for(i=0;i<game.categ.Elements.length;i++)if(game.categ.Elements[i].categ==this.clickedBox){
						obj=document.getElementById('card_'+i);
						if(obj){
							game.categ.Elements[i].x=parseInt(obj.style.left);
							game.categ.Elements[i].y=parseInt(obj.style.top);
						}
						game.categ.Elements[i].Dx=this.boxDx*this.scaleVal;
						game.categ.Elements[i].Dy=400*this.scaleVal;
						game.categ.Elements[i].Drot=0;
						game.categ.Elements[i].dx=(game.categ.Elements[i].Dx-game.categ.Elements[i].x)/20;
						game.categ.Elements[i].dy=(game.categ.Elements[i].Dy-game.categ.Elements[i].y)/20;
						game.categ.Elements[i].drot=(game.categ.Elements[i].Drot-game.categ.Elements[i].rot)/20;
					}
				}
			}else if(this.clickedBox>=0 && this.clickedBoxStatus==4){//putting the cards back in the box
				this.boxStep++;
				for(i=0;i<game.categ.Elements.length;i++)if(game.categ.Elements[i].categ==this.clickedBox){
					game.categ.Elements[i].x+=game.categ.Elements[i].dx;
					game.categ.Elements[i].y+=game.categ.Elements[i].dy;
					game.categ.Elements[i].rot+=game.categ.Elements[i].drot;
					obj=document.getElementById('card_'+i);
					if(obj){
						obj.style.left=game.categ.Elements[i].x+'px';
						obj.style.top=game.categ.Elements[i].y+'px';
						setAngle(obj,game.categ.Elements[i].rot);
						obj.style.zIndex=50+i;
						obj.style.display='block';
					}
				}
				if(this.boxStep>=20){
					this.clickedBox=-1;
					this.clickedBoxStatus=0;
					this.cardsUp();
				}
			}else if(this.clickedBox>=0 && this.clickedBoxStatus==2){//box clicked and in place, throwing the cards
				for(i=0;i<game.categ.Elements.length;i++)if(game.categ.Elements[i].categ==this.clickedBox){
					done=false;
					if(game.categ.Elements[i].x<game.categ.Elements[i].Dx && game.categ.Elements[i].dx<0)done=true;
					else if(game.categ.Elements[i].x>game.categ.Elements[i].Dx && game.categ.Elements[i].dx>0)done=true;
					else if(game.categ.Elements[i].y>game.categ.Elements[i].Dy && game.categ.Elements[i].dy>0)done=true;
					else if(game.categ.Elements[i].y<game.categ.Elements[i].Dy && game.categ.Elements[i].dy<0)done=true;
					if(done)continue;
					game.categ.Elements[i].x+=game.categ.Elements[i].dx;
					game.categ.Elements[i].y+=game.categ.Elements[i].dy;
					game.categ.Elements[i].rot+=game.categ.Elements[i].drot;
					obj=document.getElementById('card_'+i);
					if(obj){
						obj.style.left=game.categ.Elements[i].x+'px';
						obj.style.top=game.categ.Elements[i].y+'px';
						setAngle(obj,game.categ.Elements[i].rot);
						obj.style.zIndex=50+i;
						obj.style.display='block';
					}
				}
			}
		}else{
			this.clickedBox=-1;this.clickedBoxStatus=0;
			this.startingGame();
			this.cardsUp();
			this.status='game over';
			for(i=0;i<game.categ.Elements.length;i++){
				obj=document.getElementById('card_'+i);
				if(obj)obj.style.display='none';
			}
			obj=document.getElementById('UIContainer');
			if(obj)obj.style.backgroundPosition='0px -'+(100*this.scaleVal)+'px';
			obj=document.getElementById('boxesContainer');
			if(obj)obj.style.marginTop=((355)*this.scaleVal)+'px';
			var html='<div id="fireworksBackground" style="position:absolute;top:0px;left:'+(85*this.scaleVal)+'px;width:'+(550*this.scaleVal)+'px;height:'+(483*this.scaleVal)+'px;z-index:2;">';
				html+='<div id="congratsDiv" style="z-index:2;font-size:'+(61*this.scaleVal)+'px">'+game.config.menuTexts.EndScreenCongratulations+'</div>';
				html+='<div id="congratsDiv2" style="z-index:2;font-size:'+(24*this.scaleVal)+'px">'+game.config.menuTexts.EndScreenSuccessfully+'</div>';
				html+='<div id="gameOverButtons" style="z-index:2;height:'+(120*this.scaleVal)+'px;">';
					html+='<div onclick="game.newGame(game.categId);" class="menuButton" style="font-size:'+(12*this.scaleVal)+'px;width:'+(150*this.scaleVal)+'px;height:'+(27*this.scaleVal)+'px;"><div>'+game.config.menuTexts.PlayAgainButton+'</div></div>';
					html+='<div onclick="game.status=\'main menu\';" class="menuButton" style="font-size:'+(12*this.scaleVal)+'px;margin-top:3%;width:'+(150*this.scaleVal)+'px;height:'+(27*this.scaleVal)+'px;"><div>'+game.config.menuTexts.BackToMenuButton+'</div></div>';
				html+='</div>';
				html+='<div id="congratsDiv3" style="font-size:'+(16*this.scaleVal)+'px">'+game.config.menuTexts.EndScreenseeThePictures+'</div>';
			html+='</div>';
			html+='<div style="position:absolute;width:'+(720*this.scaleVal)+'px;height:'+(483*this.scaleVal)+'px;top:0px;z-index:1;"><canvas id="FireworkScanvas" width="'+(720*this.scaleVal)+'" height="'+(483*this.scaleVal)+'"></canvas></div>';
			this.mainDiv.innerHTML+=html;
			FireworksStart();			
		}
	}
	
	this.Load();
}


function preloadImage(Images,index,source){
	Images[index]=new Image();
	Images[index].loaded=false;
	Images[index].onload=function(){this.loaded=true;}
	Images[index].src=source;
}
function imagesLoaded(Images){
	if(!Images)return(true);
	var i;
	for(i=0;i<Images.length;i++)if(!Images[i].loaded)return(false);
	return(true);
}
function setAngle(obj,angle){
	if(!obj)return;
	obj.style.webkitTransform="rotate(" + angle + "deg)";
	obj.style.msTransform="rotate(" + angle + "deg)";
	obj.style.MozTransform="rotate(" + angle + "deg)";
	obj.style.OTransform="rotate(" + angle + "deg)";
	obj.style.transform="rotate(" + angle + "deg)";
}
function allowDrop(ev){ev.preventDefault();}